/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// WebhookEventType the model 'WebhookEventType'
type WebhookEventType string

// List of WebhookEventType
const (
	MessageSent WebhookEventType = "message_sent"
	MessageReceived WebhookEventType = "message_received"
	MessageReceivedAttributed WebhookEventType = "message_received_attributed"
	MessageDeleted WebhookEventType = "message_deleted"
	MessageEdited WebhookEventType = "message_edited"
	MessageSendingError WebhookEventType = "message_sending_error"
	MessageStatusChanged WebhookEventType = "message_status_changed"
	MessageMediaSynchronized WebhookEventType = "message_media_synchronized"
	ConversationOptedOut WebhookEventType = "conversation_opted_out"
	ConversationOptedIn WebhookEventType = "conversation_opted_in"
	ContactComChannelAttached WebhookEventType = "contact_com_channel_attached"
	ContactComChannelDetached WebhookEventType = "contact_com_channel_detached"
	ScriptStarted WebhookEventType = "script_started"
	ScriptFinished WebhookEventType = "script_finished"
	ContactUpdated WebhookEventType = "contact_updated"
	ContactCreated WebhookEventType = "contact_created"
	ContactDeleted WebhookEventType = "contact_deleted"
	RequestLocation WebhookEventType = "request_location"
	ConversationAttachedToTransaction WebhookEventType = "conversation_attached_to_transaction"
)

// All allowed values of WebhookEventType enum
var AllowedWebhookEventTypeEnumValues = []WebhookEventType{
	"message_sent",
	"message_received",
	"message_received_attributed",
	"message_deleted",
	"message_edited",
	"message_sending_error",
	"message_status_changed",
	"message_media_synchronized",
	"conversation_opted_out",
	"conversation_opted_in",
	"contact_com_channel_attached",
	"contact_com_channel_detached",
	"script_started",
	"script_finished",
	"contact_updated",
	"contact_created",
	"contact_deleted",
	"request_location",
	"conversation_attached_to_transaction",
}

func (v *WebhookEventType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WebhookEventType(value)
	for _, existing := range AllowedWebhookEventTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WebhookEventType", value)
}

// NewWebhookEventTypeFromValue returns a pointer to a valid WebhookEventType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWebhookEventTypeFromValue(v string) (*WebhookEventType, error) {
	ev := WebhookEventType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WebhookEventType: valid values are %v", v, AllowedWebhookEventTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WebhookEventType) IsValid() bool {
	for _, existing := range AllowedWebhookEventTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WebhookEventType value
func (v WebhookEventType) Ptr() *WebhookEventType {
	return &v
}

type NullableWebhookEventType struct {
	value *WebhookEventType
	isSet bool
}

func (v NullableWebhookEventType) Get() *WebhookEventType {
	return v.value
}

func (v *NullableWebhookEventType) Set(val *WebhookEventType) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventType) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventType(val *WebhookEventType) *NullableWebhookEventType {
	return &NullableWebhookEventType{value: val, isSet: true}
}

func (v NullableWebhookEventType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

